package com.fp.persistence.pgeneral.schedule;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import java.sql.Timestamp;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENESCHEDULELOG*/
@Entity(name="TgeneScheduleLog")
@Table(name="TGENESCHEDULELOG")
public class TgeneScheduleLog extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneScheduleLog
*/
@EmbeddedId
private TgeneScheduleLogKey pk;
@Column(name="USERCODE", nullable=true)

/**
* Codigo de usuario
*/
private String usercode;

@Column(name="PROCESSDATE", nullable=true)

/**
* Fecha de ejecucion de la tarea calendarizada
*/
private Date processdate;

@Column(name="RESULTCODE", nullable=true)

/**
* Codigo de resultado de ejecucion de la transaccion
*/
private String resultcode;

@Column(name="RESULTMESSAGE", nullable=true)

/**
* Texto de resultado de la ejecucion de la tarea calendarizada.
*/
private String resultmessage;

/**Contructor por defecto*/
public TgeneScheduleLog(){
}
/**Contructor de TgeneScheduleLog
@param pPk Clave Primaria del entity
*/
public TgeneScheduleLog(TgeneScheduleLogKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneScheduleLog
*/
public static TgeneScheduleLog find(EntityManager pEntityManager,TgeneScheduleLogKey pKey) throws Exception{
    TgeneScheduleLog obj = pEntityManager.find(TgeneScheduleLog.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneScheduleLog
@return El objeto que referencia a la Clave primaria de TgeneScheduleLog
*/
public TgeneScheduleLogKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneScheduleLog
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneScheduleLog
*/
public void setPk(TgeneScheduleLogKey pPk){
  pk=pPk;
}
/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de processdate
@return valor de processdate*/
public Date getProcessdate(){
  return processdate;
}
/**Fija el valor de processdate
@param pProcessdate nuevo Valor de processdate*/
public void setProcessdate(Date pProcessdate){
  processdate=pProcessdate;
}

/**Obtiene el valor de resultcode
@return valor de resultcode*/
public String getResultcode(){
  return resultcode;
}
/**Fija el valor de resultcode
@param pResultcode nuevo Valor de resultcode*/
public void setResultcode(String pResultcode){
  resultcode=pResultcode;
}

/**Obtiene el valor de resultmessage
@return valor de resultmessage*/
public String getResultmessage(){
  return resultmessage;
}
/**Fija el valor de resultmessage
@param pResultmessage nuevo Valor de resultmessage*/
public void setResultmessage(String pResultmessage){
  resultmessage=pResultmessage;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneScheduleLog))return false;
    TgeneScheduleLog that = (TgeneScheduleLog) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneScheduleLog
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneScheduleLog
*/
public Object createInstance(){
 TgeneScheduleLog instance=new TgeneScheduleLog();	
 instance.setPk(new TgeneScheduleLogKey());
 return instance;
}
/**Clona la entidad TgeneScheduleLog
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneScheduleLog p=(TgeneScheduleLog)this.clone();
  p.setPk((TgeneScheduleLogKey)this.pk.cloneMe());
  return p;
}
}
